# -*- encoding: utf-8 -*-
import six


def to_str(str_):
    # type: (any) -> str
    """
    Convert unicode, bytes, str and integer to str
    """
    allowed_types = (six.text_type, six.binary_type, int)

    if not isinstance(str_, allowed_types):
        raise TypeError(
            "The argument must be one of {al_t}, not {t}".format(al_t=allowed_types, t=type(str_)))

    if isinstance(str_, int):
        str_ = str(str_)

    elif not isinstance(str_, str):
        if six.PY3:
            str_ = str_.decode('utf-8')
        else:
            str_ = str_.encode('utf-8')

    return str_
